/* Sistemas Integrados TECNISA

Nome: 0330_PLATRGS.SQL

 Descrio:
 ###########################################################################################
 #             Triggers para atualizao do campo DTULTATURECE da tabela PRATO             #
 ###########################################################################################

Criao:
   05/03/2004 Leonardo Leo de Assis
*/

IF EXISTS(SELECT
             *
          FROM
             SYSOBJECTS O,
             SYSUSERS U
          WHERE
             O.NAME = 'DTULTATU_RECESERV' AND
             TYPE   = 'TR'                AND
             U.UID  = O.UID               AND
             U.NAME = USER)
  DROP TRIGGER DTULTATU_RECESERV
  GO

CREATE TRIGGER DTULTATU_RECESERV
ON
   RECESERV
FOR INSERT, UPDATE, DELETE

AS
BEGIN
  UPDATE
     PRATO
  SET
     DTULTATURECE = GETDATE()
  FROM
     INSERTED
  WHERE
     PRATO.CDPRATO = INSERTED.CDPRATO AND
     PRATO.CDFILAUXPRAT = INSERTED.CDFILAUXPRAT;
  IF @@ROWCOUNT = 0
  BEGIN
     UPDATE
        PRATO
     SET
        DTULTATURECE = GETDATE()
     FROM
        DELETED
     WHERE
        PRATO.CDPRATO = DELETED.CDPRATO AND
        PRATO.CDFILAUXPRAT = DELETED.CDFILAUXPRAT;
  END
  IF (0 <> (SELECT COUNT(*) FROM DELETED)) BEGIN /* UPDATE */
     UPDATE
        RECESERV
     SET DTULTATURECS = GETDATE()
     FROM
        INSERTED, DELETED
     WHERE
        RECESERV.CDFILAUXPRAT = INSERTED.CDFILAUXPRAT AND
        RECESERV.CDPRATO      = INSERTED.CDPRATO      AND
        RECESERV.CDPRODUTO    = INSERTED.CDPRODUTO    AND
        RECESERV.CDFILIAL     = INSERTED.CDFILIAL     AND
        RECESERV.CDSERVFILI   = INSERTED.CDSERVFILI   AND
        RECESERV.CDFILAUXPRAT = DELETED.CDFILAUXPRAT  AND
        RECESERV.CDPRATO      = DELETED.CDPRATO       AND
        RECESERV.CDPRODUTO    = DELETED.CDPRODUTO     AND
        RECESERV.CDFILIAL     = DELETED.CDFILIAL      AND
        RECESERV.CDSERVFILI   = DELETED.CDSERVFILI;
  END ELSE BEGIN  /* INSERT */
     UPDATE
        RECESERV
     SET DTULTATURECS = GETDATE()
     FROM
        INSERTED
     WHERE
        RECESERV.CDFILAUXPRAT = INSERTED.CDFILAUXPRAT AND
        RECESERV.CDPRATO      = INSERTED.CDPRATO      AND
        RECESERV.CDPRODUTO    = INSERTED.CDPRODUTO    AND
        RECESERV.CDFILIAL     = INSERTED.CDFILIAL     AND
        RECESERV.CDSERVFILI   = INSERTED.CDSERVFILI;
  END;
END;
GO

