<?php
namespace Zeedhi\Tools\DatabaseReader;

class Exception extends \Exception{

    public static function tableNotFound($tableName) {
        return new self("Table {$tableName} was not found in current database.");
    }

    public static function unsupportedConnectionDriver($driver) {
        return new self("Connection driver {$driver} not supported.");
    }

    public static function tableWithoutPrimaryKey($tableName) {
        return new self("Table {$tableName} have not got a primary key.");
    }

    public static function constraintNotFoundInDatabase($tableName, $constraintName) {
        return new self("Constraint {$constraintName} of table {$tableName} not found in current database.");
    }

    public static function unsupportedDeleteRule($deleteRule){
        return new self("Unsupported delete rule {$deleteRule}");
    }

    public static function sequenceDoesNotExist($tableName, $columnName) {
        return new self("Sequence for table {$tableName} and column {$columnName} does not exist.");
    }

}